# Julia Challenge

Can you solve all the puzzles in noteboook `Challenge.ipynb`?

## Contents
[Test driven development](https://en.wikipedia.org/wiki/Test-driven_development) is not only interesting, but also good for learning a new language.
Notebook `Challenge.ipynb` contains a lot of tasks specified by tests.
These tests cover

* Toolchain for numerical simulations (also, see the list of toolchain for physicists [here](ToolChain.md))
* Write Julia functions
* Write simulated annealing

Another important aspect that Julia is different from other language is package development.
This part will be covered [here](DevelopGuide.md)

## Get Started
1. install julia 1.0 from [here](https://julialang.org/downloads/) and install IJulia from [here](https://github.com/JuliaLang/IJulia.jl),
2. clone this repo to your local host
```bash
$ git clone https://github.com/QuantumBFS/JuliaChallenge.git
$ cd JuliaChallenge
```
3. open the notebook and **pass all the tests**!
```bash
$ jupyter notebook Challenge.ipynb
```

## Author
[JinGuo Liu](https://giggleliu.github.io/)

If you appreciate this repo, please donate me with Wechat pay (1-10 RBM for quality ranking)

![](data/barcode.png)

This project is motivated by [Numeric Club](http://num.v2nobel.com)
